/* 
 * glass "Hello World"
 *
 * Copyright (C) 2001  Robert Ancell <bob27@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* compile with `make' */

#include <GL/glut.h>
#include <glass.h>

void init(void);
void reshape(int x, int y);
void display(void);
int main(int argc, char **argv);

GlassObject *example_object;

void init(void)
{
  /* Set up glut */
  glutInitDisplayMode(GLUT_RGB | GLUT_SINGLE);
  glutCreateWindow("Hello world! (glass)");
  glutReshapeFunc(reshape);
  glutDisplayFunc(display);

  /* Load the glass object */
  example_object = glassLoadObject("models/hello.model");
}

void reshape(int w, int h)
{
  glViewport(0, 0, (GLsizei) w, (GLsizei) h); 
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(60.0, (GLfloat) w/(GLfloat) h, 0.5, 10000.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

void display(void)
{
  glClear(GL_COLOR_BUFFER_BIT);

  glMatrixMode(GL_MODELVIEW);

  glLoadIdentity();
  glTranslatef(0.0, 0.0, -10.0);

  /* Draws our glass object */
  glassDrawObject(example_object);

  glFlush();
}

int main(int argc, char **argv)
{
  glutInit(&argc, argv);
  init();

  glutMainLoop();

  return 0;
}
